package org.paw.filter;


import sunlabs.brazil.server.Request;
import sunlabs.brazil.server.Server;
import sunlabs.brazil.util.http.MimeHeaders;
import sunlabs.brazil.filter.Filter;
import sunlabs.brazil.util.regexp.Regexp;

import java.io.*;
import java.util.*;

import org.paw.util.*;


public class RepackFilter implements Filter
{
   String prefix;

   public boolean init(Server server, String prefix)
   {
      this.prefix = prefix;

      return true;
   }

   /**
      * This is the request object before the content was fetched
      */

   public boolean respond(Request request)
   {
      return false;
   }

   /**
      * Only filter text/plain documents
      */

   public boolean shouldFilter(Request request, MimeHeaders headers)
   {
      // If data is compressed return true
      String type = headers.get("content-encoding");

      return (type != null);
   
   }

   public byte[] filter(Request request, MimeHeaders headers,
           byte[] content)
   {

      String encodingHeader = headers.get("content-encoding");

      if (encodingHeader.equals("gzip") || encodingHeader.equals("x-gzip"))
      {
         headers.remove("X-PAW-DECOMPRESSED");
         return Pack.zipData(content);
      }
      else if (encodingHeader.equals("compress") ||
              encodingHeader.equals("x-compress"))
      {
         headers.remove("X-PAW-DECOMPRESSED");
         return Pack.compressData(content);
      }
     else {
         return content;
     }
   }

}


