/*
 * AdminServerPrefs.java
 *
 * Created on 28. Juli 2001, 18:35
 */

package org.paw.gui;


import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;


/**
 *
 * @author  Standard
 * @version 
 */
public class AdminServerPrefs extends JPanel implements ActionListener {
    private GuiAdminConfig config;
    private JPanel panel;
    private GridBagLayout gbl;
    private GridBagConstraints gbc;

    private static Image bgImage;
    private static int backgroundImageWidth;
    private static int backgroundImageHeight;
    private String bgImageName = "backgrounds/infoBackground.jpg";
    private Color background = Color.white;
     
    private JCheckBox  useAdmin;
    private JTextField port,
        user;
    private JPasswordField
        pass,
        pass2;
    
    /** Creates newEmptyPanel */
    public AdminServerPrefs(DefaultMutableTreeNode node) {
        super();
        
        Object object = node.getUserObject();

        config = (GuiAdminConfig) object;
        
        setLayout(new BorderLayout());

        // Initialize background image
        bgImage = Toolkit.getDefaultToolkit().getImage(bgImageName);
        MediaTracker tracker = new MediaTracker(this);

        tracker.addImage(bgImage, 0); 
        try {
            tracker.waitForAll();
        } catch (InterruptedException e) {}
        
        backgroundImageWidth = bgImage.getWidth(null);
        backgroundImageHeight = bgImage.getHeight(null);

        setupPanel();
    }

    private void setupPanel() {
        JToolBar toolBar = new JToolBar();      

        toolBar.setFloatable(false);
        toolBar.setBackground(Color.gray);
        
        JButton saveButton = new JButton(new ImageIcon("gui_images/apply.gif"));

        saveButton.setBackground(Color.gray);
        saveButton.setToolTipText("Apply");
        saveButton.addActionListener(this);
        saveButton.setActionCommand("Apply");
        saveButton.setBorderPainted(false);
        saveButton.addMouseListener(new FlatLookMouseListener());
        
        toolBar.add(saveButton);
        
        JLabel title = new JLabel("  " + "Admin Server Configuration");

        title.setForeground(Color.white);
        title.setFont(new Font("SansSerif", Font.BOLD, Icons.BigIconHeight));
        
        toolBar.add(title);
        
        add(toolBar, "North");

        panel = new JPanel() {
                    public void paintComponent(Graphics g) {
                        super.paintComponent(g); 
                        g.drawImage(bgImage, 0, 0, backgroundImageWidth, backgroundImageHeight, null);
                    }
                };

        panel.setBackground(background);
        
        JScrollPane scroller = new JScrollPane(panel);
        
        gbl = new GridBagLayout();
        gbc = new GridBagConstraints();
        panel.setLayout(gbl);
        
        add(scroller, "Center");
        
        addServerInfo();
    }
        
    private void addServerInfo() {
        useAdmin = new JCheckBox("Use Admin Server", config.isActive());
        useAdmin.setBackground(background);
        
        port = new JTextField(config.getPort(), 4);
        port.setBackground(background);
        
        user = new JTextField(config.getUser(), 10);
        user.setBackground(background);
        
        pass = new JPasswordField(config.getPass(), 10);
        pass.setBackground(background);
        
        pass2 = new JPasswordField(config.getPass(), 10);
        pass2.setBackground(background);
        
        addComponent(useAdmin, GridBagConstraints.REMAINDER);
        
        addComponent(new Label("Port: "), 1);
        addComponent(port, GridBagConstraints.REMAINDER);
        
        addComponent(new Label("User: "), 1);
        addComponent(user, GridBagConstraints.REMAINDER);
        
        addComponent(new Label("Password: "), 1);
        addComponent(pass, GridBagConstraints.REMAINDER);
        
        addComponent(new Label("Repeat password: "), 1);
        addComponent(pass2, GridBagConstraints.REMAINDER);
      
    }
    
    private void addComponent(Component component, int width) {
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = width;
        gbc.insets = new Insets(1, 1, 1, 1);
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbl.setConstraints(component, gbc);
        panel.add(component);
    }
    
    private void addComponent(Component component, int width,
        int top, int left, int bottom, int right) {
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = width;
        gbc.insets = new Insets(top, left, bottom, right);
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbl.setConstraints(component, gbc);
        panel.add(component);
    }       
     
    public void actionPerformed(ActionEvent e) {
        if (e.getActionCommand().equals("Apply")) {    
            String p1 = new String(pass.getPassword());
            String p2 = new String(pass2.getPassword());
           
            if (useAdmin.isSelected()) {
                if (!p1.equals(p2)) {
                    JOptionPane.showMessageDialog(this,
                        "Passwords do not match. Please verify Input.",
                        "Password Error",
                        JOptionPane.ERROR_MESSAGE);
                    return;
                }
            }
            
            config.setActive(useAdmin.isSelected());
            config.setPort(port.getText());
            config.setUser(user.getText());
            config.setPass(p1);
        }
    }
    
}
