package org.paw.gui;


import java.awt.*;
import javax.swing.*;


class AuthDialog extends JDialog {
 
    // Define Labels TextFields and Buttons
    private JLabel userLabel = new JLabel("Username: ");
    private JLabel passLabel = new JLabel("Password: "); 
    private JTextField user = new JTextField(15);
    private JPasswordField pass = new JPasswordField(15);
    private JButton okButton = new JButton("  Ok  ");
    private JButton cancelButton = new JButton("Cancel");

    public AuthDialog(Frame parent, boolean modal) {
        super(parent, modal); 
        setupPanel();
    }

    public void setupPanel() {
        this.setTitle("Authenticate");
        this.setResizable(false);

        GridBagLayout gbl = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();

        this.getContentPane().setLayout(gbl);
        this.setBackground(Color.lightGray);

        JLabel title = new JLabel("Please enter user name and password");

        title.setIcon(new ImageIcon("gui_images/user.gif"));

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gbc.insets = new Insets(10, 10, 10, 10);
        gbc.anchor = GridBagConstraints.NORTH;
        gbl.setConstraints(title, gbc);
        this.getContentPane().add(title);

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = 1;
        gbc.insets = new Insets(1, 10, 1, 1);
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbl.setConstraints(userLabel, gbc);
        this.getContentPane().add(userLabel);

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gbc.insets = new Insets(1, 1, 1, 10);
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbl.setConstraints(user, gbc);
        this.getContentPane().add(user);

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = 1;
        gbc.insets = new Insets(1, 10, 1, 1);
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbl.setConstraints(passLabel, gbc);
        this.getContentPane().add(passLabel);

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gbc.insets = new Insets(1, 1, 1, 10);
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbl.setConstraints(pass, gbc);
        this.getContentPane().add(pass);

        JPanel buttonPanel = new JPanel();

        buttonPanel.add(okButton);
        buttonPanel.add(cancelButton);
        getRootPane().setDefaultButton(okButton);

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gbc.insets = new Insets(10, 1, 1, 1);
        gbc.anchor = GridBagConstraints.SOUTH;

        gbl.setConstraints(buttonPanel, gbc);
        this.getContentPane().add(buttonPanel);

        this.pack();
    }

    public String getUser() {
        return user.getText();
    } 
     
    public String getPass() {
        return new String(pass.getPassword());
    } 

    public void setButtonActionListerner(MainWindow frame) {
        okButton.addActionListener(frame); 
        okButton.setActionCommand("AuthUser"); 

        cancelButton.addActionListener(frame); 
        cancelButton.setActionCommand("AuthUserCancel");
    }
}
