package org.paw.gui;


import java.awt.*;
import javax.swing.*;


class ConnectionDialog extends JDialog {
 
    // Define Labels TextFields and Buttons
    private JLabel serverNameLabel = new JLabel("PAW Server: ");
    private JLabel serverPortLabel = new JLabel("Port: "); 
    private JTextField serverName = new JTextField(15);
    private JTextField serverPort = new JTextField(6);
    private JButton connectButton = new JButton("Connect");
    private JButton cancelButton = new JButton("Cancel");

    public ConnectionDialog(Frame parent, boolean modal) {
        super(parent, modal); 
        setupPanel();
    }

    public void setupPanel() {
        this.setTitle("Connect");
        this.setResizable(false);

        GridBagLayout gbl = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();

        this.getContentPane().setLayout(gbl);
        this.setBackground(Color.lightGray);

        JLabel title = new JLabel("Please specify PAW Server");

        title.setIcon(new ImageIcon("gui_images/connect.gif"));

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gbc.insets = new Insets(10, 10, 10, 10);
        gbc.anchor = GridBagConstraints.NORTH;
        gbl.setConstraints(title, gbc);
        this.getContentPane().add(title);

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = 1;
        gbc.insets = new Insets(1, 10, 1, 1);
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbl.setConstraints(serverNameLabel, gbc);
        this.getContentPane().add(serverNameLabel);

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gbc.insets = new Insets(1, 1, 1, 10);
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbl.setConstraints(serverName, gbc);
        this.getContentPane().add(serverName);

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = 1;
        gbc.insets = new Insets(1, 10, 1, 1);
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbl.setConstraints(serverPortLabel, gbc);
        this.getContentPane().add(serverPortLabel);

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gbc.insets = new Insets(1, 1, 1, 10);
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbl.setConstraints(serverPort, gbc);
        this.getContentPane().add(serverPort);

        JPanel buttonPanel = new JPanel();

        buttonPanel.add(connectButton);
        buttonPanel.add(cancelButton);
        getRootPane().setDefaultButton(connectButton);

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gbc.insets = new Insets(10, 1, 1, 1);
        gbc.anchor = GridBagConstraints.SOUTH;

        gbl.setConstraints(buttonPanel, gbc);
        this.getContentPane().add(buttonPanel);

        this.pack();
    }

    public String getServerName() {
        return serverName.getText();
    } 
     
    public String getServerPort() {
        return serverPort.getText();
    } 

    public void setButtonActionListerner(MainWindow frame) {
        connectButton.addActionListener(frame); 
        connectButton.setActionCommand("ConnectToHost"); 

        cancelButton.addActionListener(frame); 
        cancelButton.setActionCommand("ConnectCancel");
    }
}
