/*
 * GuiHandler.java
 *
 * Created on 28. Juli 2001, 12:11
 */

package org.paw.gui;


import java.io.*;
import java.util.*;


/**
 *
 * @author  Standard
 * @version 
 */
public class GuiHandler {

    String status = null;
    String name = null;
    String description = null;
    boolean removable = false;
    String id = null;
    Vector params = new Vector();
    boolean active = false;
    
    // Use hash to avoid multiple entries
    Hashtable files = new Hashtable();
    
    private Hashtable classes = new Hashtable();
    
    /** Creates new GuiHandler */
    public GuiHandler() {}
    
    public void setStatus(String status) {
        this.status = status;
    }
    
    public String getStatus() {
        return this.status;
    }
    
    public void setActive(boolean active) {
        this.active = active;
    }
    
    public boolean isActive() {
        return active;
    }
    
    public void setName(String name) {
        this.name = name;
    }
    
    public String getName() {
        return this.name;
    }
    
    public void setDescription(String description) {
        this.description = description;
    }
    
    public String getDescription() {
        return this.description;
    }
    
    public void setRemovable(boolean removable) {
        this.removable = removable;
    }
    
    public boolean isRemovable() {
        return this.removable;
    }
    
    public void setId(String id) {
        this.id = id;
    }
    
    public String getId() {
        return this.id;
    }
    
    public void addParam(String param, String value) {
        // If param points to class save it in classes hash
        if (param.endsWith(".class"))
            classes.put(value, "");
        
        params.add(new GuiParam(param, value));
    }
    
    public boolean hasClass(String className) {
        return (classes.get(className) != null ? true : false);
    }
    
    public Vector getParams() {
        return this.params;
    }
    
    public void addFile(String file) {
        files.put(file, "");
    }
    
    public Hashtable getFiles() {
        return files;
    }

}
