package org.paw.gui;


import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.html.*;


public class HelpFrame extends JFrame
    implements HyperlinkListener {
    
    public HelpFrame(String title) {

        setTitle(title);
      
        Image frameImage =
            Toolkit.getDefaultToolkit().getImage("gui_images/framelogo.gif");

        setIconImage(frameImage);

        setBackground(Color.lightGray);
      
        String urlString = "file:///";

        urlString += System.getProperty("user.dir");
        urlString += File.separator + "html"; 
        urlString += File.separator + "index.html";

        //JEditorPane infoPane = new JEditorPane("text/html", content);
        JEditorPane infoPane = new JEditorPane();

        infoPane.setEditable(false);
        infoPane.addHyperlinkListener(this);
      
        try {
            infoPane.setPage(urlString);
        } catch (Exception e) {
            System.out.println("Invalid destination string");
        }
      
        JScrollPane scroller = new JScrollPane(infoPane);
                
        JPanel contentPane = (JPanel) getContentPane();
      
        contentPane.add(scroller);
 
        this.setSize(600, 400);
   	
    }

    public void hyperlinkUpdate(HyperlinkEvent e) {
        if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
            JEditorPane pane = (JEditorPane) e.getSource();

            if (e instanceof HTMLFrameHyperlinkEvent) {
                HTMLFrameHyperlinkEvent  evt = (HTMLFrameHyperlinkEvent) e;
                HTMLDocument doc = (HTMLDocument) pane.getDocument();

                doc.processHTMLFrameHyperlinkEvent(evt);
            } else {
                try {
                    pane.setPage(e.getURL());
                } catch (Throwable t) {
                    t.printStackTrace();
                }
            }
        }
    }
   	  
}

