/*
 * LogoWindow.java
 *
 * Created on 29. Juli 2001, 07:53
 */

package org.paw.gui;


import java.awt.*;
import javax.swing.*;


/**
 *
 * @author  Standard
 * @version 
 */
public class LogoWindow extends JFrame {
    private JWindow window;
    private Toolkit toolkit;
    private JLabel label;
    private JLabel message;

    /** Creates new LogoWindow */
    public LogoWindow(String logo) {
        toolkit = Toolkit.getDefaultToolkit();
        window = new JWindow();
        window.getContentPane().setBackground(Color.lightGray);
        
        label = new JLabel(new ImageIcon(logo));
        label.setBorder(BorderFactory.createRaisedBevelBorder());
        window.getContentPane().add(label, BorderLayout.CENTER);
        
        message = new JLabel("PAW starting up...");
	message.setOpaque(true);
	message.setBackground(Color.black);
	message.setForeground(Color.white);
        window.getContentPane().add(message, BorderLayout.SOUTH);
        
        centerWindow();
        window.show();
    }
    
    public void setMessage(String message) {
        this.message.setText(message);
    }
    
    private void centerWindow() {
        Dimension screenSize = toolkit.getScreenSize();
        Dimension labelSize = label.getPreferredSize();
        int labelWidth = labelSize.width;
        int labelHeight = labelSize.height;
        
        window.setLocation(screenSize.width / 2 - (labelWidth / 2),
            screenSize.height / 2 - (labelHeight / 2));
        
        window.pack();
    }
    
    public void showWindow() {
        window.show();
    }
    
    public void disposeWindow() {
        window.dispose();
    }
    
}
