package org.paw.gui;


import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*; 


/**
 * Main class of JTag programm. Calls the mainWindow class
 * to display the JTag window.
 *
 */
public class PawGui {
    public static void main(String args[]) {
	 
        MainWindow frame;
	 
        /* Choose random splashscreen image */
        String[] images = new File("gui_images/splashscreens").list(new ImageFileFilter());
        int random = new Random().nextInt(images.length);

        LogoWindow window = new LogoWindow("gui_images/splashscreens/" + images[random]);

        window.showWindow();
	 
        frame = new MainWindow("PAW Gui");

        frame.doUI();
		
        frame.setSize(600, 400);

        window.setMessage("Trying local connect..");
         
        if (frame.logonLocally())
            window.setMessage("Connected to localhost...");
        else
            window.setMessage("Local connect failed...");
         
        window.disposeWindow();
         
        frame.setVisible(true);
		 
    }
    
 
}


class ImageFileFilter implements FilenameFilter
{
    public boolean accept( File dir, String name )
    {
      if (name.toLowerCase().endsWith(".gif") ||
                    name.toLowerCase().endsWith(".jpg") ) {
        return true;
      }
      else {
        return false;
      } 
    }
}
