/*
 * ServerPrefs.java
 *
 * Created on 28. Juli 2001, 18:35
 */

package org.paw.gui;


import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;


/**
 *
 * @author  Standard
 * @version 
 */
public class ServerPrefs extends JPanel implements ActionListener {
    private GuiServerConfig config;
    private JPanel panel;
    private GridBagLayout gbl;
    private GridBagConstraints gbc;

    private static Image bgImage;
    private static int backgroundImageWidth;
    private static int backgroundImageHeight;
    private String bgImageName = "backgrounds/infoBackground.jpg";
    private Color background = Color.white;
     
    private JCheckBox  useProxy;
    private JTextField port,
        log,
        proxy,
        proxyPort;
  
    /** Creates newEmptyPanel */
    public ServerPrefs(DefaultMutableTreeNode node) {
        super();
        
        Object object = node.getUserObject();

        config = (GuiServerConfig) object;
        
        setLayout(new BorderLayout());

        // Initialize background image
        bgImage = Toolkit.getDefaultToolkit().getImage(bgImageName);
        MediaTracker tracker = new MediaTracker(this);

        tracker.addImage(bgImage, 0); 
        try {
            tracker.waitForAll();
        } catch (InterruptedException e) {}
        
        backgroundImageWidth = bgImage.getWidth(null);
        backgroundImageHeight = bgImage.getHeight(null);

        setupPanel();
    }

    private void setupPanel() {
        JToolBar toolBar = new JToolBar();      

        toolBar.setFloatable(false);
        toolBar.setBackground(Color.gray);
        
        JButton saveButton = new JButton(new ImageIcon("gui_images/apply.gif"));

        saveButton.setBackground(Color.gray);
        saveButton.setToolTipText("Apply");
        saveButton.addActionListener(this);
        saveButton.setActionCommand("Apply");
        saveButton.setBorderPainted(false);
        saveButton.addMouseListener(new FlatLookMouseListener());
        
        toolBar.add(saveButton);
        
        JLabel title = new JLabel("  " + "Server Configuration");

        title.setForeground(Color.white);
        title.setFont(new Font("SansSerif", Font.BOLD, Icons.BigIconHeight));
        
        toolBar.add(title);
        
        add(toolBar, "North");

        panel = new JPanel() {
                    public void paintComponent(Graphics g) {
                        super.paintComponent(g); 
                        g.drawImage(bgImage, 0, 0, backgroundImageWidth, backgroundImageHeight, null);
                    }
                };

        panel.setBackground(background);
        
        JScrollPane scroller = new JScrollPane(panel);
        
        gbl = new GridBagLayout();
        gbc = new GridBagConstraints();
        panel.setLayout(gbl);
        
        add(scroller, "Center");
        
        addServerInfo();
    }
        
    private void addServerInfo() {
        useProxy = new JCheckBox("Use Proxy Server", config.useProxy());
        useProxy.setBackground(background);
        
        port = new JTextField(config.getPort(), 4);
        port.setBackground(background);
        
        log = new JTextField(config.getLog(), 2);
        log.setBackground(background);
        
        proxy = new JTextField(config.getProxyHost(), 10);
        proxy.setBackground(background);
        
        proxyPort = new JTextField(config.getProxyPort(), 4);
        proxyPort.setBackground(background);
        
        addComponent(new Label("Port: "), 1);
        addComponent(port, GridBagConstraints.REMAINDER);
        
        addComponent(new Label("Log level: "), 1);
        addComponent(log, GridBagConstraints.REMAINDER);
        addComponent(new Label("(0=min ... 5=max)"),
            GridBagConstraints.REMAINDER);
        
        addComponent(useProxy, GridBagConstraints.REMAINDER, 20, 1, 1, 1);
        
        addComponent(new Label("Proxy: "), 1);
        addComponent(proxy, GridBagConstraints.REMAINDER);
        
        addComponent(new Label("Proxy port: "), 1);
        addComponent(proxyPort, GridBagConstraints.REMAINDER);
      
    }
    
    private void addComponent(Component component, int width) {
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = width;
        gbc.insets = new Insets(1, 1, 1, 1);
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbl.setConstraints(component, gbc);
        panel.add(component);
    }
    
    private void addComponent(Component component, int width,
        int top, int left, int bottom, int right) {
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = width;
        gbc.insets = new Insets(top, left, bottom, right);
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbl.setConstraints(component, gbc);
        panel.add(component);
    }       
     
    public void actionPerformed(ActionEvent e) {
        if (e.getActionCommand().equals("Apply")) {   
            config.setUseProxy(useProxy.isSelected());
            config.setPort(port.getText());
            config.setLog(log.getText());
            config.setProxyHost(proxy.getText());
            config.setProxyPort(proxyPort.getText());
        }
    }
    
}
